/**
*   Nombre del Programa: Caminante
*   Proyecto: Aplicacin Android de Asistencia al Caminante
*   Uso: ayuda a pacientes con enfermedad de Parkinson 
*   	que presentan problemas de movilidad.
*   Acciones: Marcha, Anti Bloqueo y Anti Cada.
*   Medios: emisin de sonidos
**/    
/**    
    Copyright (C) 2011 Enrique Ramn Delgado Garrido

    This program is free software: you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, either version 3 of the License, or 
    (at your option) any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

package com.caminante.paquete;

import android.content.Context;
//import android.media.MediaPlayer;
//import android.util.Log;

public class FuncionBloqueoCaida extends SensorsService { 

	private	long	acelTiempoArray[]	=	new	long	[2];
	
	public 	float	paramGravedad2  	= 	0;
	public 	float	paramGravedad	  	= 	0;
	public	float	paramModulo			=	0;
	public	int		paramEvento			=	0;
	public	int		bloqueoEvento		=	0;
	public	float	paramBloqueoT		=	0;
	public	int		paramAccionBloqueo	=	5;
	public 	int 	bloqueoTiempo		=	0;
	public 	int 	bloqueoTieEve		=	0;

	private	long 	timeStamp			= 	0;
	static  float	timeNano			=	(float) 1.E-9;
	
	private int 	bloqueo			=	0;
	private int 	comparador[][]	= 	new int[3][3];
	private int		i_bloqueo 		= 	0;
	private int		i_countBloqueo	=	0;
	private int 	i_cociente		=	0;
	private int		returnBloqueo	= 	0;
	
	private int 	caida			=	0;
	private int		i_caida 		= 	0;
	private int		i_countCaida	=	0;
	
	private int		paramEventoCaida = 0;
	public 	float	paramPendienteCaida	=	0; 
	
	private int		returnCaida			= 	0;
	public	int		returnBloqueoCaida	= 	0;
	
	private	float	moduloAceleracion2	=	0;

	public	float	gradienteModulo[]	=	new	float	[2];
	public	long	gradienteTiempo[]	=	new	long	[2];
	public	int		intervaloArray[]	=	new	int		[2];
	
	public 	float	pendienteCaida		=	0; 
	//private SobresaltoMediaPlayer sMediaPlayer;
	
	
	public 	Context	ctxFB;
	public 	Context	ctxFC;
	
	public	int		tAC;
	public  int		tAB;

	public FuncionBloqueoCaida(Context ctx, float mGravedad, float mModulo, int mEventoBloqueo, float  mBloqueoT, boolean mAccionBloqueo,
						       				int   mEventoCaida, float mPendienteCaida) {
		
		FuncionBloqueo(ctx, mGravedad, mModulo, mEventoBloqueo, mBloqueoT, mAccionBloqueo);
		FuncionCaida  (ctx, mEventoCaida, mPendienteCaida);

	}
	public FuncionBloqueoCaida(Context ctx, float mGravedad, float mModulo, int mEventoBloqueo, float mBloqueoT, boolean mAccionBloqueo) {
		
		FuncionBloqueo(ctx, mGravedad, mModulo, mEventoBloqueo, mBloqueoT, mAccionBloqueo);
		
	}
	
	private void FuncionBloqueo(Context ctx, float mGravedad, float mModulo, int mEventoBloqueo, float mBloqueoT, boolean mAccionBloqueo) {

		ctxFB = ctx;
		paramGravedad  	= mGravedad;
		paramGravedad2	= (float) Math.pow(this.paramGravedad, 2);
		paramModulo 	= mModulo;
		paramEvento 	= mEventoBloqueo;
		paramBloqueoT 	= mBloqueoT;
		if (mAccionBloqueo) {
			paramAccionBloqueo = 1;
		} else {
			paramAccionBloqueo = 5;
		}
		inicializarComparador();
		acelTiempoArray[0]  = (long) 0;
		acelTiempoArray[1]  = (long) 0;
		bloqueoEvento       = 0;
		bloqueoTiempo       = 0;
		bloqueoTieEve		= 0;
		i_countBloqueo		= 0;
	}

	//private SobresaltoMediaPlayer sMediaPlayer;
	
	
	public FuncionBloqueoCaida(Context ctx, int mEventoCaida, float mPendienteCaida) {
		
		   FuncionCaida(ctx, mEventoCaida, mPendienteCaida);
		   
	}
	private void FuncionCaida(Context ctx, int mEventoCaida, float mPendienteCaida) {
		
		ctxFC = ctx;
		paramEventoCaida 	= mEventoCaida;
		paramPendienteCaida	= mPendienteCaida;
		gradienteTiempo[0] 	= (long) 0;
		gradienteTiempo[1] 	= (long) 0;
		gradienteModulo[0] 	= (long) 0;
		gradienteModulo[1] 	= (long) 0;
		i_countCaida = 0;
	}

	public int tratarACELBloqueoCaida(float ca0, float ca1, float ca2, long ftimeStamp) {
		//timeStamp = new Timestamp(Calendar.getInstance().getTimeInMillis()).getTime();	
		timeStamp = ftimeStamp;
		moduloAceleracion2 = ((float) Math.pow(ca0, 2)+(float) Math.pow(ca1, 2)+
                			  (float) Math.pow(ca2, 2));
		tAC = tratarACELCaida();
		tAB	= tratarACELBloqueo();
		
		return Math.max(tAC, tAB);
	}
	
	public int 	tratarACELBloqueo (float ca0, float ca1, float ca2, long ftimeStamp){
		//long timeStamp = new Timestamp(Calendar.getInstance().getTimeInMillis()).getTime();	
		timeStamp = ftimeStamp;
		moduloAceleracion2 = ((float) Math.pow(ca0, 2)+(float) Math.pow(ca1, 2)+
  			  				  (float) Math.pow(ca2, 2));
		return tratarACELBloqueo();
	}
// ------------------------------------------------------------------
	public int 	tratarACELBloqueo() {
		i_countBloqueo++;
		//Log.i ("BLOQUEO ", Long.toString(i_countBloqueo)+ " "+Long.toString(timeStamp));
		bloqueo = bloqueoFunction();
		switch ( bloqueo ) {
			case 0 : {
				returnBloqueo		= 0;
				if ((bloqueoTiempo != 0) || (bloqueoEvento != 0)) {
					//Log.i ("Fin de la Parada", "parada");
					//SMediaPlayer(ctxFB);
		            //sMediaPlayer.stop();
					returnBloqueo	= 99;
		        } 
				i_bloqueo 			= 0; 
		        bloqueoTiempo 		= 0; 
		        bloqueoEvento 		= 0;
		        bloqueoTieEve		= 0;
		        acelTiempoArray[0] 	= (long) 0; 
		        acelTiempoArray[1] 	= (long) 0;
		        inicializarComparador();		
				i_countBloqueo 			= 0;
				break;
			}
			default : {
				i_bloqueo++;	i_cociente 	= 1/i_bloqueo;
				acelTiempoArray[i_cociente] = timeStamp;
				bloqueoDefault();
				break;
			}
		}
		return 	returnBloqueo;
	}

	private void bloqueoDefault() {
		
		switch (bloqueoTieEve) {
			case 5 :
				//sMediaPlayer = new SobresaltoMediaPlayer(ctxFB, 5, R.raw.do_3);
				//sMediaPlayer.start();	
				returnBloqueo = 6;
				break;				
			default :						
				for (int i = paramAccionBloqueo ; i > 0 ; i--) {
					//if (((acelTiempoArray[0] - acelTiempoArray[1])/1000000.) > (i * paramBloqueoT * 1000)) {
					if (((acelTiempoArray[0] - acelTiempoArray[1])*timeNano) > (i * paramBloqueoT)) {
						returnBloqueo = 0;
						if (bloqueoTieEve < i) {
							bloqueoTiempo = i;
							//Log.i ("Paradatiempo", Integer.toString(i)+"  "+(acelTiempoArray[0] - acelTiempoArray[1]));
							//sMediaPlayer = new SobresaltoMediaPlayer(ctxFB, i, R.raw.do_3);
							//sMediaPlayer.start();
							bloqueoTieEve = Math.max(bloqueoTiempo, bloqueoEvento);
							returnBloqueo = bloqueoTieEve;
						}
						break;
					}
				}
		/**		for (int i = paramAccionBloqueo ; i > 0 ; i--) {
					if (i_bloqueo > i * paramEvento ) {
						returnBloqueo = 0;
						if (bloqueoTieEve < i) {
							bloqueoEvento = i;
							//Log.i ("Paradaevento", Integer.toString(i));
							//sMediaPlayer = new SobresaltoMediaPlayer(ctxFB, i, R.raw.do_3);
							//sMediaPlayer.start();
							bloqueoTieEve = Math.max(bloqueoTiempo, bloqueoEvento);
							returnBloqueo = bloqueoTieEve;
						}
						break;
					}
				} **/
		}
	}	

	public int bloqueoFunction () {
		
		int  f_bloqueo 	= 0;
		int  f_indice 	= 0;
		
		float dif = Math.abs(moduloAceleracion2 - paramGravedad2);
		
		if (dif <= paramModulo) {
			f_indice = 0;
			comparador[0][1]=0;
			comparador[1][0]=0;
			comparador[2][0]=0;			
		} else {
			if (dif <= paramModulo*2) {
				f_indice = 1;
				comparador[f_indice][1]++;
			} else {
				f_indice = 2;
				comparador[f_indice][1]++;
			}
		}
		comparador[f_indice][0]++;
		if ((comparador[f_indice][0]<=comparador[f_indice][2]-1) &&
			(comparador[f_indice][1]<=(comparador[f_indice][2]))) {
			f_bloqueo = comparador[0][0];
		}
		return f_bloqueo;	
	}
	
	public void inicializarComparador () {
		for (int i = 0; i < 3; i++) {
			for (int j = 0; i < 2; i++) {
					comparador[i][j]	=	0;
			}		
		}
		comparador[0][2]	=	999999999;
		comparador[1][2]	=	3;
		comparador[2][2]	=	2;
	}
//----------------------------------------------------------------------------
/**
	void 	tratarORIE (String dirORIE, String ficORIE) {
	}	
/*
/**	public void SMediaPlayer(Context ctx , int iV) {
		sMediaPlayer = new SobresaltoMediaPlayer(ctx, iV, R.raw.tick);
    }	
*/
//-----------------------------------------------------------------------------
	public int 	tratarACELCaida (float ca0, float ca1, float ca2, long ftimeStamp) throws NumberFormatException {	
		//timeStamp = new Timestamp(Calendar.getInstance().getTimeInMillis()).getTime();	
		timeStamp = ftimeStamp;
		moduloAceleracion2 = ((float) Math.pow(ca0, 2)+(float) Math.pow(ca1, 2)+
  			  				  (float) Math.pow(ca2, 2));
		return tratarACELCaida();
	}
	public int 	tratarACELCaida () throws NumberFormatException {
		i_countCaida++;
		//Log.i ("CAIDA ", Long.toString(i_countCaida)+ " "+Long.toString(timeStamp));
		returnCaida = 0;
		switch (i_countCaida) {
			case 1  : {			  				
				gradienteTiempo[0]	= timeStamp;
				gradienteModulo[0]	= moduloAceleracion2;
				break;
			}
			default : {
		  		gradienteTiempo[1]	= timeStamp;
				gradienteModulo[1]	= moduloAceleracion2;

				caida = caidaFunction();
				switch ( caida ) {
					case 0 : {
						i_caida 		= 0; 
						break;
					}
					default : {
						i_caida++;
						//Log.i ("caida real", Integer.toString(i_caida)+"  "+Integer.toString(paramEventoCaida));
						if (i_caida > paramEventoCaida) {
							returnCaida = caida;
						}
						break;
					}
				}
				gradienteTiempo[0]	= 	gradienteTiempo[1];
				gradienteModulo[0]	=	gradienteModulo[1];
				break;
			}
		}
		return returnCaida;
	}
	
	public int caidaFunction() {
		int f_caida = 0;	
		pendienteCaida 	= 	(float) Math.atan((gradienteModulo[1]-gradienteModulo[0])/(gradienteTiempo[1]-gradienteTiempo[0]));		
		if (pendienteCaida > paramPendienteCaida * 1.E-6) {
			//Log.i ( "caida ", i_countCaida+"  "+pendienteCaida);
			f_caida = 100;
		}	
		return f_caida;
	}
}
