/**
*   Nombre del Programa: Caminante
*   Proyecto: Aplicacin Android de Asistencia al Caminante
*   Uso: ayuda a pacientes con enfermedad de Parkinson 
*   	que presentan problemas de movilidad.
*   Acciones: Marcha, Anti Bloqueo y Anti Cada.
*   Medios: emisin de sonidos
**/    
/**    
    Copyright (C) 2011 Enrique Ramn Delgado Garrido

    This program is free software: you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, either version 3 of the License, or 
    (at your option) any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

package com.caminante.paquete;

import com.caminante.paquete.R;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;
import android.widget.ToggleButton;

public class MenuCaminante extends Activity {

	public static  ToggleButton tButtonMarcha	= null;
	public static  ToggleButton tButtonBloqueo	= null;
	public static  ToggleButton tButtonCaida	= null;
	public static  Button 		btnMarcha		= null;
	public static  Button 		btnBloqueo		= null;
	public static  Button 		btnCaida		= null;
	public static  Button 		btnCerrar		= null;

//	de METRONOMO -- Marcha -----------------------------------
				   TickPlayer 	tickPlayer 		= null;
	
	private static final int 	DEFAULT_TEMPO	= 90;
	private static final int 	DEFAULT_PERIOD 	= 2;
	private int 				mTempo 			= DEFAULT_TEMPO;
	private int 				mPeriod 		= DEFAULT_PERIOD;

	private static final String KEY_TEMPO 		= "METRONOME_TEMPO";
	private static final String KEY_PERIOD 		= "METRONOME_PERIOD";

	private boolean				runningMarcha	= false;
//	fin de METRONOMO ----------------------------------
 
//  de SENSORES -- bloqueo y caida ------------------------------------

	private static final float		DEFAULT_GRAVEDAD  		=	(float) 9.80665;
	private static final float		DEFAULT_MODULO	  		=	12;
	private static final int		DEFAULT_EVENTO_BLOQUEO  =	75;
	private static final float		DEFAULT_BLOQUEO_T 		=	1;
	private static final boolean	DEFAULT_ACCION_BLOQUEO	=	false;
	
	private	float				mGravedad		  	=	DEFAULT_GRAVEDAD;
	private	float				mModulo			  	=	DEFAULT_MODULO;
	private	int					mEventoBloqueo 	  	= 	DEFAULT_EVENTO_BLOQUEO;
	private	float				mBloqueoT 		  	=	DEFAULT_BLOQUEO_T;
	private	boolean				mAccionBloqueo	  	=	DEFAULT_ACCION_BLOQUEO;
		
	private static final String	KEY_GRAVEDAD 	  	=	"BLOQUEO_GRAVEDAD";
	private static final String	KEY_MODULO	  	  	=	"BLOQUEO_MODULO";
	private static final String	KEY_EVENTO_BLOQUEO  =	"BLOQUEO_EVENTO";
	private static final String	KEY_BLOQUEO_T 	  	=	"BLOQUEO_BLOQUEO_T";
	private static final String	KEY_ACCION_BLOQUEO 	=	"BLOQUEO_ACCION";

	private static final int	DEFAULT_EVENTO_CAIDA  	=	3;
	private static final float	DEFAULT_PENDIENTE_CAIDA =	(float)1.2;
	private	int					mEventoCaida 	  		= 	DEFAULT_EVENTO_CAIDA;
	private float				mPendienteCaida 		=	DEFAULT_PENDIENTE_CAIDA;
	
	private static final String	KEY_EVENTO_CAIDA  		=	"CAIDA_EVENTO";
	private static final String	KEY_PENDIENTE_CAIDA  	=	"CAIDA_PENDIENTE";
	
	static	float[] 			coordenadasZero	= new float[3];
	
	private boolean				runningBloqueo	= false;
	private boolean				runningCaida	= false;
	private boolean				runningType[]	= new boolean[2];

//  de HILOS -----------------------------------
	final	 			Handler		handlerMarcha		= new Handler();
	final	 			Handler		handlerBloqueo		= new Handler();
	final	 			Handler		handlerCaida		= new Handler();

    private volatile 	Thread 		blinkerMarcha;
    private volatile 	Thread 		blinkerBloqueo;
    private volatile 	Thread 		blinkerCaida;

//  fin de HILOS -----------------------------------

//  -----------------------------------
	private static final String PREFS = "parameterswalker.prefs";
//  -----------------------------------
	
//  Hilo Marcha -----------------------
	protected void hiloMarcha() {
		
		Thread tMarcha = new Thread () {
			public void run() {
				try {
					Thread.sleep(1000);
				} catch(InterruptedException e) {
					e.printStackTrace();
				}
				handlerMarcha.post(accionMarcha);
			}
		};
		tMarcha.start();
	}

	final Runnable accionMarcha = new Runnable() {
		public void run() {
			setRunningMarcha(true);
			tickPlayer.onStart(mPeriod, mTempo);
		}
	};

    private void stopMarcha() {
    	setRunningMarcha(false);
    	tickPlayer.onStop();
       	setBlinkerMarcha(null);
    }	
//  Hilo Marcha -----------------------

//  Hilo Bloqueo -----------------------

	protected void hiloBloqueo() {
		if (runningCaida) {
			stopService(new Intent(this, SensorsService.class));
		}
		Thread tBloqueo = new Thread () {
			public void run() {
				try {
					Thread.sleep(1000);
				} catch(InterruptedException e) {
					e.printStackTrace();
				}
				handlerBloqueo.post(accionBloqueo);
			}
		};
		tBloqueo.start();
	}

	final Runnable accionBloqueo = new Runnable() {		
		public void run() {
			runningBloqueo = true;
			startService(intentService());
		}
	};

    private void stopBloqueo() {
 		runningBloqueo = false;
		stopService(new Intent(this, SensorsService.class));
     	setBlinkerBloqueo(null);
     	if (runningCaida) {
 			hiloCaida();	
  		}
    }
    
//  FIN Hilo Bloqueo -----------------------
    
//  Hilo Caida -----------------------

    protected void hiloCaida() {
	    if (runningBloqueo) {
			stopService(new Intent(this, SensorsService.class));
		}
		Thread tCaida = new Thread () {
			public void run() {
				try {
					Thread.sleep(1000);
				} catch(InterruptedException e) {
					e.printStackTrace();
				}
				handlerCaida.post(accionCaida);
			}
		};
		tCaida.start();
	}

	final Runnable accionCaida = new Runnable() {		
		public void run() {
			runningCaida = true;
			startService(intentService());
		}
	};

	private void stopCaida() {
		runningCaida = false;
		stopService(new Intent(this, SensorsService.class));
  		setBlinkerCaida(null);
		if (runningBloqueo) {
 			hiloBloqueo();	
  		}
	}

//  FIN Hilo Caida -----------------------

	private Intent intentService(){
		Intent intent = new Intent();
		//intent.setClass(getBaseContext(), SensorsService.class);
		intent.setClass(getApplicationContext(), SensorsService.class);      //(getBaseContext(), SensorsService.class);
		Bundle bundle = new Bundle();
		if (runningBloqueo) {
			bundle.putFloat		(KEY_GRAVEDAD,  		mGravedad);
			bundle.putFloat		(KEY_MODULO,    		mModulo);
			bundle.putInt  		(KEY_EVENTO_BLOQUEO,    mEventoBloqueo);
			bundle.putFloat		(KEY_BLOQUEO_T, 		mBloqueoT);
			bundle.putBoolean	(KEY_ACCION_BLOQUEO, 	mAccionBloqueo);
		}
		if (runningCaida) {
			//Log.i ("runningCaida", Integer.toString(mEventoCaida));
			bundle.putInt  (KEY_EVENTO_CAIDA, 		mEventoCaida);
			bundle.putFloat(KEY_PENDIENTE_CAIDA, 	mPendienteCaida);
			}		
		runningType[0] = runningBloqueo;
		runningType[1] = runningCaida;
		bundle.putBooleanArray("RUNNING_TYPE", runningType);
		intent.putExtras(bundle);
		return intent;
	}
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        registerReceiver(receiver, new IntentFilter(Intent.ACTION_VIEW));
    	
        setContentView(R.layout.main);
 
        SharedPreferences settings = getSharedPreferences(PREFS, 0);
        mPeriod 		= settings.getInt  		(KEY_PERIOD, 			DEFAULT_PERIOD);
        mTempo 			= settings.getInt  		(KEY_TEMPO,  			DEFAULT_TEMPO);
        mGravedad		= settings.getFloat		(KEY_GRAVEDAD, 			DEFAULT_GRAVEDAD);
        mModulo			= settings.getFloat		(KEY_MODULO,    		DEFAULT_MODULO);
    	mEventoBloqueo 	= settings.getInt  		(KEY_EVENTO_BLOQUEO,	DEFAULT_EVENTO_BLOQUEO);
    	mBloqueoT   	= settings.getFloat		(KEY_BLOQUEO_T, 		DEFAULT_BLOQUEO_T);
    	mAccionBloqueo 	= settings.getBoolean	(KEY_ACCION_BLOQUEO, 	DEFAULT_ACCION_BLOQUEO);
    	mEventoCaida 	= settings.getInt  		(KEY_EVENTO_CAIDA,		DEFAULT_EVENTO_CAIDA);
    	mPendienteCaida = settings.getFloat		(KEY_PENDIENTE_CAIDA, 	DEFAULT_PENDIENTE_CAIDA);
    	        
        // inicializacin botones
        tButtonMarcha	= (ToggleButton) 	findViewById(R.id.TButtonMarcha);
        tButtonMarcha.setEnabled(true);
        btnMarcha 		= (Button) 			findViewById(R.id.ButtonMarcha);
        
        tButtonBloqueo 	= (ToggleButton) 	findViewById(R.id.TButtonBloqueo);
        tButtonBloqueo.setEnabled(true);
        btnBloqueo 		= (Button) 			findViewById(R.id.ButtonBloqueo);

        tButtonCaida 	= (ToggleButton) 	findViewById(R.id.TButtonCaida);
        tButtonCaida.setEnabled(true);
        btnCaida 		= (Button) 			findViewById(R.id.ButtonCaida);
                
      //--- Marcha ---
        tickPlayer = new TickPlayer(this);
        tButtonMarcha.setOnClickListener(new View.OnClickListener() {	
        	public void onClick(View v) {
        		if (((ToggleButton)v).isChecked()) {
                    //DisplayToast("Toggle button Marcha is On");
                    btnMarcha.setEnabled(false);
                    hiloMarcha();
                } else { 
                   	//DisplayToast("Toggle button Marcha is Off");
                   	stopMarcha();
                   	btnMarcha.setEnabled(true);
                }
        	}
        }); 
        
        final MyDialogMetronomo dialogMetronomo = new MyDialogMetronomo(this, mPeriod , mTempo, new OnReadyListenerMarcha());  
        btnMarcha.setText("Periodo " + mPeriod + " Tempo " + mTempo);

        btnMarcha.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
                //Toast.makeText(getBaseContext(), 
        		//		"You have clicked the Marcha button", 
        		//		Toast.LENGTH_SHORT).show();
                try {
                	dialogMetronomo.show();
				}
				catch (Exception e) {
					Log.i(getClass().getSimpleName(), e.getMessage());
				}						
			}
        });

    	//--- Bloqueo ---
         
         tButtonBloqueo.setOnClickListener(new View.OnClickListener() 
         {	public void onClick(View v) {
				if (((ToggleButton)v).isChecked()) {
	                //DisplayToast("Toggle button Bloqueo is On");
				    btnBloqueo.setEnabled(false);
				    hiloBloqueo();
				} else { 
					//DisplayToast("Toggle button Bloqueo is Off");
				   	stopBloqueo();
				   	btnBloqueo.setEnabled(true);
				}
            }
         }); 

         final MyDialogBloqueo dialogBloqueo = new MyDialogBloqueo(this, 
        		 mGravedad, mModulo, mEventoBloqueo , mBloqueoT, mAccionBloqueo, new OnReadyListenerBloqueo());  
         btnBloqueo.setText("Configuracin");
        
         btnBloqueo.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
                //Toast.makeText(getBaseContext(), 
                //		"You have clicked the Bloqueo button", 
                //        Toast.LENGTH_SHORT).show();
                try {
                	dialogBloqueo.show();
				} catch (Exception e) {
					Log.i(getClass().getSimpleName(), e.getMessage());
				}						
        	}
        });
         
        //--- Caida ---
        tButtonCaida.setOnClickListener(new View.OnClickListener() 
        {	public void onClick(View v) {
               if (((ToggleButton)v).isChecked()) {
                    //DisplayToast("Toggle button Caida is On");
 				    btnCaida.setEnabled(false);
				    hiloCaida();     
               } else {
                   	//DisplayToast("Toggle button Caida is Off");
				   	stopCaida();
				   	btnCaida.setEnabled(true);
               }
			}
        });
        
        final MyDialogCaida dialogCaida = new MyDialogCaida(this, mEventoCaida, mPendienteCaida, new OnReadyListenerCaida());  
        btnCaida.setText("Configuracin");
        
        btnCaida.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		//Toast.makeText(getBaseContext(),
        		//		"You have clicked the Caida button",
        		//		Toast.LENGTH_SHORT).show();
        		try {
                	dialogCaida.show();
				} catch (Exception e) {
					Log.i(getClass().getSimpleName(), e.getMessage());
				}
        	}
        });
        
    }

    void DisplayToast(String msg)
    {
         Toast.makeText(getBaseContext(), msg, 
                 Toast.LENGTH_SHORT).show();        
    }    
	protected void onStop() {;
		super.onStop();
		SharedPreferences settings = getSharedPreferences(PREFS, 0);
		SharedPreferences.Editor editor = settings.edit();
		editor.putInt  		(KEY_PERIOD,    		mPeriod);
		editor.putInt  		(KEY_TEMPO,     		mTempo);
		editor.putFloat		(KEY_GRAVEDAD,  		mGravedad);
		editor.putFloat		(KEY_MODULO,    		mModulo);
		editor.putInt  		(KEY_EVENTO_BLOQUEO, 	mEventoBloqueo);
		editor.putFloat		(KEY_BLOQUEO_T, 		mBloqueoT);
		editor.putBoolean	(KEY_ACCION_BLOQUEO, 	mAccionBloqueo);
		editor.putInt  		(KEY_EVENTO_CAIDA,   	mEventoCaida);
		editor.putFloat		(KEY_PENDIENTE_CAIDA,  	mPendienteCaida);
		editor.commit();
		finish();
	}
    protected void onDestroy() {
    	if (tButtonMarcha.getText().toString().equals(tButtonMarcha.getTextOn().toString())) {
   			stopMarcha();
   			tickPlayer.onDestroy();
   			//Log.i ("cerrar1",tButtonMarcha.getText().toString());
		}
   		if ((runningBloqueo) || (runningCaida)) {
			//stopBloqueo();
   			//stopCaida();
   			stopService(new Intent(this, SensorsService.class));
   	  		setBlinkerBloqueo(null);
   			setBlinkerCaida(null);
		}
   		unregisterReceiver(receiver);
		super.onDestroy();
    }
 	public void setBlinkerMarcha(Thread blinkerMarcha) {
		this.blinkerMarcha = blinkerMarcha;
	}

	public Thread getBlinkerMarcha() {
		return blinkerMarcha;
	}
	public void setBlinkerBloqueo(Thread blinkerBloqueo) {
		this.blinkerBloqueo = blinkerBloqueo;
	}

	public Thread getBlinkerBloqueo() {
		return blinkerBloqueo;
	}
	public void setBlinkerCaida(Thread blinkerCaida) {
		this.blinkerCaida = blinkerCaida;
	}

	public Thread getBlinkerCaida() {
		return blinkerCaida;
	}
	
	public void setRunningMarcha(boolean runningMarcha) {
		this.runningMarcha = runningMarcha;
	}

	public boolean isRunningMarcha() {
		return runningMarcha;
	}

	private class OnReadyListenerMarcha implements MyDialogMetronomo.ReadyListener {
    	@Override
    	public void ready(int numPeriod, int numTempo) {
    		mPeriod = numPeriod;
    		mTempo  = numTempo;
    		btnMarcha.setText("Periodo " + mPeriod + " Tempo " + mTempo);
    	}
    }
/****/
    private class OnReadyListenerBloqueo implements MyDialogBloqueo.ReadyListener {
    	@Override
    	public void ready(float numGravedad, float numModulo, int numEventoBloqueo, float numBloqueoT, boolean booAccionBloqueo) {
    		mGravedad  		= numGravedad;
    		mModulo    		= numModulo;
    		mEventoBloqueo 	= numEventoBloqueo;
    		mBloqueoT  		= numBloqueoT;
    		mAccionBloqueo	= booAccionBloqueo;
    		btnBloqueo.setText("Configuracin");
    	}
    }    
    
    private class OnReadyListenerCaida implements MyDialogCaida.ReadyListener {
    	@Override
    	public void ready(int numEventoCaida, float numPendienteCaida) {
    		mEventoCaida 	= numEventoCaida;
    		mPendienteCaida = numPendienteCaida;
    		btnCaida.setText("Configuracin");
    	}
    }

    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
        	//Intent service = new Intent(MenuCaminante.this, SensorsService.class);
        	int myICaida  	= 0;
        	int myIBloqueo 	= 0;
        	myICaida = intent.getIntExtra("CAIDA", myICaida);
        	myIBloqueo = intent.getIntExtra("BLOQUEO", myIBloqueo);
        	Log.i ("receiver ", "receiver "+ Integer.toString(myIBloqueo)+" "+ Integer.toString(myIBloqueo));
    		if (myICaida==1) {
        		Log.i ("receiver ", "caida");
        		tButtonCaida.setChecked(false);
            	//unregisterReceiver(receiver);
    		   	stopCaida();
    		   	btnCaida.setEnabled(true);	
        	}
        	if (myIBloqueo==1) {
        		Log.i ("receiver ", "bloqueo");
        		tButtonBloqueo.setChecked(false);
            	//unregisterReceiver(receiver);
            	stopBloqueo();
            	btnBloqueo.setEnabled(true);
        	}
        }
    };

}
