/**
*   Nombre del Programa: Caminante
*   Proyecto: Aplicacin Android de Asistencia al Caminante
*   Uso: ayuda a pacientes con enfermedad de Parkinson 
*   	que presentan problemas de movilidad.
*   Acciones: Marcha, Anti Bloqueo y Anti Cada.
*   Medios: emisin de sonidos
**/    
/**    
    Copyright (C) 2011 Enrique Ramn Delgado Garrido

    This program is free software: you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, either version 3 of the License, or 
    (at your option) any later version. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

package com.caminante.paquete;

import android.content.Context;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.util.Log;

public class SobresaltoMediaPlayer {
	
	private MediaPlayer		sMediaPlayer;
	private Float			volumen;
	
	public SobresaltoMediaPlayer(Context ctx, int numVolumen, int resId) {
		sMediaPlayer = new MediaPlayer();
		//sMediaPlayer.setOnCompletionListener(completionListener);
		sMediaPlayer = MediaPlayer.create(ctx, resId);
		sMediaPlayer.setLooping(false);
		sMediaPlayer.setOnErrorListener(new MediaPlayer.OnErrorListener() {
			//@Override
			public boolean onError(MediaPlayer mp, int what, int extra) {
				Log.v("SobresaltoMediaPlayer", "error on media player what=" + what + " extra=" + extra);
				return false;
			}
		});
		volumen =  ((float) numVolumen) * (float) VolAudioManager(ctx) / 5;
		//Log.i("volumen", volumen.toString());
		sMediaPlayer.setVolume(volumen, volumen);
	}
	
	public int VolAudioManager(Context ctx) {
		AudioManager am = (AudioManager) ctx.getSystemService(Context.AUDIO_SERVICE); 
		int volMax = am.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
		return volMax;
	}

	public void start() {
			if (!sMediaPlayer.isPlaying()) {
				sMediaPlayer.start();
				return;
			}
		}

	public void stop() {
			if (sMediaPlayer.isPlaying())
				sMediaPlayer.stop();
		}	

}